Index: drivers/filesystems/btrfs/extent-tree.c
===================================================================
--- drivers/filesystems/btrfs/extent-tree.c	(révision 75772)
+++ drivers/filesystems/btrfs/extent-tree.c	(copie de travail)
@@ -1119,95 +1238,120 @@
                 return STATUS_INTERNAL_ERROR;
             }
         }
-        
+
         len -= sectlen;
         ptr += sizeof(UINT8) + sectlen;
         inline_rc += sectcount;
     }
-    
+
     if (inline_rc == ei->refcount) {
         ERR("entry not found in inline extent item for address %llx\n", address);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
+    if (type == TYPE_SHARED_DATA_REF)
+        datalen = sizeof(UINT32);
+    else if (type == TYPE_TREE_BLOCK_REF || type == TYPE_SHARED_BLOCK_REF)
+        datalen = 0;
+
     searchkey.obj_id = address;
     searchkey.obj_type = type;
     searchkey.offset = (type == TYPE_SHARED_DATA_REF || type == TYPE_EXTENT_REF_V0) ? parent : get_extent_hash(type, data);
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp2, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     if (keycmp(tp2.item->key, searchkey)) {
         ERR("(%llx,%x,%llx) not found\n", tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     if (tp2.item->size < datalen) {
-        ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, datalen);
+        ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset, tp2.item->size, datalen);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     if (type == TYPE_EXTENT_DATA_REF) {
         EXTENT_DATA_REF* sectedr = (EXTENT_DATA_REF*)tp2.item->data;
         EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)data;
-        EXTENT_ITEM* newei;
-        
+
         if (sectedr->root == edr->root && sectedr->objid == edr->objid && sectedr->offset == edr->offset) {
+            EXTENT_ITEM* newei;
+
             if (ei->refcount == edr->count) {
-                delete_tree_item(Vcb, &tp, rollback);
-                delete_tree_item(Vcb, &tp2, rollback);
-                
+                Status = delete_tree_item(Vcb, &tp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    return Status;
+                }
+
+                Status = delete_tree_item(Vcb, &tp2);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    return Status;
+                }
+
                 if (!superseded)
-                    add_checksum_entry(Vcb, address, size / Vcb->superblock.sector_size, NULL, Irp, rollback);
-                
+                    add_checksum_entry(Vcb, address, (ULONG)(size / Vcb->superblock.sector_size), NULL, Irp);
+
                 return STATUS_SUCCESS;
             }
-            
+
             if (sectedr->count < edr->count) {
                 ERR("error - extent section has refcount %x, trying to reduce by %x\n", sectedr->count, edr->count);
                 return STATUS_INTERNAL_ERROR;
             }
-            
-            delete_tree_item(Vcb, &tp2, rollback);
-            
+
+            Status = delete_tree_item(Vcb, &tp2);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
             if (sectedr->count > edr->count) {
                 EXTENT_DATA_REF* newedr = ExAllocatePoolWithTag(PagedPool, tp2.item->size, ALLOC_TAG);
-                
+
                 if (!newedr) {
                     ERR("out of memory\n");
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 RtlCopyMemory(newedr, sectedr, tp2.item->size);
-                
+
                 newedr->count -= edr->count;
-                
-                if (!insert_tree_item(Vcb, Vcb->extent_root, tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset, newedr, tp2.item->size, NULL, Irp, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
+
+                Status = insert_tree_item(Vcb, Vcb->extent_root, tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset, newedr, tp2.item->size, NULL, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
             }
-            
+
             newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
             if (!newei) {
                 ERR("out of memory\n");
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             RtlCopyMemory(newei, tp.item->data, tp.item->size);
 
             newei->refcount -= rc;
-            
-            delete_tree_item(Vcb, &tp, rollback);
-            
-            if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
+
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
             }
-            
+
+            Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
             return STATUS_SUCCESS;
         } else {
             ERR("error - hash collision?\n");
@@ -1214,173 +1358,185 @@
             return STATUS_INTERNAL_ERROR;
         }
     } else if (type == TYPE_SHARED_DATA_REF) {
-        SHARED_DATA_REF* sectsdr = (SHARED_DATA_REF*)tp2.item->data;
         SHARED_DATA_REF* sdr = (SHARED_DATA_REF*)data;
-        EXTENT_ITEM* newei;
-        
-        if (sectsdr->offset == sdr->offset) {
+
+        if (tp2.item->key.offset == sdr->offset) {
+            UINT32* sectsdrcount = (UINT32*)tp2.item->data;
+            EXTENT_ITEM* newei;
+
             if (ei->refcount == sdr->count) {
-                delete_tree_item(Vcb, &tp, rollback);
-                delete_tree_item(Vcb, &tp2, rollback);
-                
+                Status = delete_tree_item(Vcb, &tp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    return Status;
+                }
+
+                Status = delete_tree_item(Vcb, &tp2);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    return Status;
+                }
+
                 if (!superseded)
-                    add_checksum_entry(Vcb, address, size / Vcb->superblock.sector_size, NULL, Irp, rollback);
-                
+                    add_checksum_entry(Vcb, address, (ULONG)(size / Vcb->superblock.sector_size), NULL, Irp);
+
                 return STATUS_SUCCESS;
             }
-            
-            if (sectsdr->count < sdr->count) {
-                ERR("error - extent section has refcount %x, trying to reduce by %x\n", sectsdr->count, sdr->count);
+
+            if (*sectsdrcount < sdr->count) {
+                ERR("error - extent section has refcount %x, trying to reduce by %x\n", *sectsdrcount, sdr->count);
                 return STATUS_INTERNAL_ERROR;
             }
-            
-            delete_tree_item(Vcb, &tp2, rollback);
-            
-            if (sectsdr->count > sdr->count) {
-                SHARED_DATA_REF* newsdr = ExAllocatePoolWithTag(PagedPool, tp2.item->size, ALLOC_TAG);
-                
+
+            Status = delete_tree_item(Vcb, &tp2);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
+            if (*sectsdrcount > sdr->count) {
+                UINT32* newsdr = ExAllocatePoolWithTag(PagedPool, tp2.item->size, ALLOC_TAG);
+
                 if (!newsdr) {
                     ERR("out of memory\n");
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
-                RtlCopyMemory(newsdr, sectsdr, tp2.item->size);
-                
-                newsdr->count -= sdr->count;
-                
-                if (!insert_tree_item(Vcb, Vcb->extent_root, tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset, newsdr, tp2.item->size, NULL, Irp, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
+
+                *newsdr = *sectsdrcount - sdr->count;
+
+                Status = insert_tree_item(Vcb, Vcb->extent_root, tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset, newsdr, tp2.item->size, NULL, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
             }
-            
+
             newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
             if (!newei) {
                 ERR("out of memory\n");
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             RtlCopyMemory(newei, tp.item->data, tp.item->size);
 
             newei->refcount -= rc;
-            
-            delete_tree_item(Vcb, &tp, rollback);
-            
-            if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
+
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
             }
-            
-            return STATUS_SUCCESS;
-        } else {
-            ERR("error - collision?\n");
-            return STATUS_INTERNAL_ERROR;
-        }
-    } else if (type == TYPE_SHARED_BLOCK_REF) {
-        SHARED_BLOCK_REF* sectsbr = (SHARED_BLOCK_REF*)tp2.item->data;
-        SHARED_BLOCK_REF* sbr = (SHARED_BLOCK_REF*)data;
-        EXTENT_ITEM* newei;
-        
-        if (sectsbr->offset == sbr->offset) {
-            if (ei->refcount == 1) {
-                delete_tree_item(Vcb, &tp, rollback);
-                delete_tree_item(Vcb, &tp2, rollback);
-                return STATUS_SUCCESS;
+
+            Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                return Status;
             }
-            
-            delete_tree_item(Vcb, &tp2, rollback);
-            
-            newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
-            if (!newei) {
-                ERR("out of memory\n");
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
-            RtlCopyMemory(newei, tp.item->data, tp.item->size);
 
-            newei->refcount -= rc;
-            
-            delete_tree_item(Vcb, &tp, rollback);
-            
-            if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
-            }
-            
             return STATUS_SUCCESS;
         } else {
             ERR("error - collision?\n");
             return STATUS_INTERNAL_ERROR;
         }
-    } else if (type == TYPE_TREE_BLOCK_REF) {
-        TREE_BLOCK_REF* secttbr = (TREE_BLOCK_REF*)tp2.item->data;
-        TREE_BLOCK_REF* tbr = (TREE_BLOCK_REF*)data;
+    } else if (type == TYPE_TREE_BLOCK_REF || type == TYPE_SHARED_BLOCK_REF) {
         EXTENT_ITEM* newei;
-        
-        if (secttbr->offset == tbr->offset) {
-            if (ei->refcount == 1) {
-                delete_tree_item(Vcb, &tp, rollback);
-                delete_tree_item(Vcb, &tp2, rollback);
-                return STATUS_SUCCESS;
+
+        if (ei->refcount == 1) {
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
             }
-            
-            delete_tree_item(Vcb, &tp2, rollback);
-            
-            newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
-            if (!newei) {
-                ERR("out of memory\n");
-                return STATUS_INSUFFICIENT_RESOURCES;
+
+            Status = delete_tree_item(Vcb, &tp2);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
             }
-            
-            RtlCopyMemory(newei, tp.item->data, tp.item->size);
 
-            newei->refcount -= rc;
-            
-            delete_tree_item(Vcb, &tp, rollback);
-            
-            if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
-            }
-            
             return STATUS_SUCCESS;
-        } else {
-            ERR("error - collision?\n");
-            return STATUS_INTERNAL_ERROR;
         }
+
+        Status = delete_tree_item(Vcb, &tp2);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+
+        newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
+        if (!newei) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        RtlCopyMemory(newei, tp.item->data, tp.item->size);
+
+        newei->refcount -= rc;
+
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+
+        Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            return Status;
+        }
+
+        return STATUS_SUCCESS;
     } else if (type == TYPE_EXTENT_REF_V0) {
         EXTENT_REF_V0* erv0 = (EXTENT_REF_V0*)tp2.item->data;
         EXTENT_ITEM* newei;
-        
+
         if (ei->refcount == erv0->count) {
-            delete_tree_item(Vcb, &tp, rollback);
-            delete_tree_item(Vcb, &tp2, rollback);
-            
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
+            Status = delete_tree_item(Vcb, &tp2);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
             if (!superseded)
-                add_checksum_entry(Vcb, address, size / Vcb->superblock.sector_size, NULL, Irp, rollback);
-            
+                add_checksum_entry(Vcb, address, (ULONG)(size / Vcb->superblock.sector_size), NULL, Irp);
+
             return STATUS_SUCCESS;
         }
-        
-        delete_tree_item(Vcb, &tp2, rollback);
-        
+
+        Status = delete_tree_item(Vcb, &tp2);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+
         newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
         if (!newei) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         RtlCopyMemory(newei, tp.item->data, tp.item->size);
 
         newei->refcount -= rc;
-        
-        delete_tree_item(Vcb, &tp, rollback);
-        
-        if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-            ERR("insert_tree_item failed\n");
-            return STATUS_INTERNAL_ERROR;
+
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
         }
-        
+
+        Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            return Status;
+        }
+
         return STATUS_SUCCESS;
     } else {
         ERR("unhandled extent type %x\n", type);
@@ -1389,64 +1545,63 @@
 }
 
 NTSTATUS decrease_extent_refcount_data(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 root, UINT64 inode,
-                                       UINT64 offset, UINT32 refcount, BOOL superseded, PIRP Irp, LIST_ENTRY* rollback) {
+                                       UINT64 offset, UINT32 refcount, BOOL superseded, PIRP Irp) {
     EXTENT_DATA_REF edr;
-    
+
     edr.root = root;
     edr.objid = inode;
     edr.offset = offset;
     edr.count = refcount;
-    
-    return decrease_extent_refcount(Vcb, address, size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, 0, superseded, Irp, rollback);
+
+    return decrease_extent_refcount(Vcb, address, size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, 0, superseded, Irp);
 }
 
 NTSTATUS decrease_extent_refcount_tree(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 root,
-                                       UINT8 level, PIRP Irp, LIST_ENTRY* rollback) {
+                                       UINT8 level, PIRP Irp) {
     TREE_BLOCK_REF tbr;
-    
+
     tbr.offset = root;
-    
-    return decrease_extent_refcount(Vcb, address, size, TYPE_TREE_BLOCK_REF, &tbr, NULL/*FIXME*/, level, 0, FALSE, Irp, rollback);
+
+    return decrease_extent_refcount(Vcb, address, size, TYPE_TREE_BLOCK_REF, &tbr, NULL/*FIXME*/, level, 0, FALSE, Irp);
 }
 
-static UINT64 find_extent_data_refcount(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 root, UINT64 objid, UINT64 offset, PIRP Irp) {
+static UINT32 find_extent_data_refcount(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 root, UINT64 objid, UINT64 offset, PIRP Irp) {
     NTSTATUS Status;
     KEY searchkey;
     traverse_ptr tp;
-    EXTENT_DATA_REF* edr;
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return 0;
     }
-    
+
     if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
         TRACE("could not find address %llx in extent tree\n", address);
         return 0;
     }
-    
+
     if (tp.item->key.offset != size) {
         ERR("extent %llx had size %llx, not %llx as expected\n", address, tp.item->key.offset, size);
         return 0;
     }
-    
+
     if (tp.item->size >= sizeof(EXTENT_ITEM)) {
         EXTENT_ITEM* ei = (EXTENT_ITEM*)tp.item->data;
         UINT32 len = tp.item->size - sizeof(EXTENT_ITEM);
         UINT8* ptr = (UINT8*)&ei[1];
-        
+
         while (len > 0) {
             UINT8 secttype = *ptr;
             ULONG sectlen = get_extent_data_len(secttype);
-            UINT64 sectcount = get_extent_data_refcount(secttype, ptr + sizeof(UINT8));
-            
+            UINT32 sectcount = get_extent_data_refcount(secttype, ptr + sizeof(UINT8));
+
             len--;
-            
+
             if (sectlen > len) {
                 ERR("(%llx,%x,%llx): %x bytes left, expecting at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, len, sectlen);
                 return 0;
@@ -1456,39 +1611,39 @@
                 ERR("(%llx,%x,%llx): unrecognized extent type %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, secttype);
                 return 0;
             }
-            
+
             if (secttype == TYPE_EXTENT_DATA_REF) {
                 EXTENT_DATA_REF* sectedr = (EXTENT_DATA_REF*)(ptr + sizeof(UINT8));
-                
+
                 if (sectedr->root == root && sectedr->objid == objid && sectedr->offset == offset)
                     return sectcount;
             }
-            
+
             len -= sectlen;
             ptr += sizeof(UINT8) + sectlen;
         }
     }
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = TYPE_EXTENT_DATA_REF;
     searchkey.offset = get_extent_data_ref_hash2(root, objid, offset);
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return 0;
     }
-    
-    if (!keycmp(searchkey, tp.item->key)) {    
+
+    if (!keycmp(searchkey, tp.item->key)) {
         if (tp.item->size < sizeof(EXTENT_DATA_REF))
             ERR("(%llx,%x,%llx) has size %u, not %u as expected\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_DATA_REF));
-        else {    
-            edr = (EXTENT_DATA_REF*)tp.item->data;
-            
+        else {
+            EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)tp.item->data;
+
             return edr->count;
         }
     }
-    
+
     return 0;
 }
 
@@ -1497,24 +1652,24 @@
     traverse_ptr tp;
     NTSTATUS Status;
     EXTENT_ITEM* ei;
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA ? TYPE_METADATA_ITEM : TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return 0;
     }
-    
+
     if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA && tp.item->key.obj_id == address &&
         tp.item->key.obj_type == TYPE_METADATA_ITEM && tp.item->size >= sizeof(EXTENT_ITEM)) {
         ei = (EXTENT_ITEM*)tp.item->data;
-    
+
         return ei->refcount;
     }
-    
+
     if (tp.item->key.obj_id != address || tp.item->key.obj_type != TYPE_EXTENT_ITEM) {
         ERR("couldn't find (%llx,%x,%llx) in extent tree\n", address, TYPE_EXTENT_ITEM, size);
         return 0;
@@ -1522,19 +1677,19 @@
         ERR("extent %llx had size %llx, not %llx as expected\n", address, tp.item->key.offset, size);
         return 0;
     }
-    
+
     if (tp.item->size == sizeof(EXTENT_ITEM_V0)) {
         EXTENT_ITEM_V0* eiv0 = (EXTENT_ITEM_V0*)tp.item->data;
-        
+
         return eiv0->refcount;
     } else if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx) was %x bytes, expected at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type,
-                                                                       tp.item->key.offset, tp.item->size, sizeof(EXTENT_DATA));
+                                                                       tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return 0;
     }
-    
+
     ei = (EXTENT_ITEM*)tp.item->data;
-    
+
     return ei->refcount;
 }
 
@@ -1542,69 +1697,69 @@
     KEY searchkey;
     traverse_ptr tp, next_tp;
     NTSTATUS Status;
-    UINT64 rc, rcrun, root = 0, inode = 0;
+    UINT64 rc, rcrun, root = 0, inode = 0, offset = 0;
     UINT32 len;
     EXTENT_ITEM* ei;
     UINT8* ptr;
     BOOL b;
-    
+
     rc = get_extent_refcount(Vcb, address, size, Irp);
 
     if (rc == 1)
         return TRUE;
-    
+
     if (rc == 0)
         return FALSE;
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = TYPE_EXTENT_ITEM;
     searchkey.offset = size;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         WARN("error - find_item returned %08x\n", Status);
         return FALSE;
     }
-    
+
     if (keycmp(tp.item->key, searchkey)) {
         WARN("could not find (%llx,%x,%llx)\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
         return FALSE;
     }
-    
+
     if (tp.item->size == sizeof(EXTENT_ITEM_V0))
         return FALSE;
-    
+
     if (tp.item->size < sizeof(EXTENT_ITEM)) {
         WARN("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return FALSE;
     }
-    
+
     ei = (EXTENT_ITEM*)tp.item->data;
-    
+
     len = tp.item->size - sizeof(EXTENT_ITEM);
     ptr = (UINT8*)&ei[1];
-    
+
     if (ei->flags & EXTENT_ITEM_TREE_BLOCK) {
         if (tp.item->size < sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2)) {
             WARN("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2));
             return FALSE;
         }
-        
+
         len -= sizeof(EXTENT_ITEM2);
         ptr += sizeof(EXTENT_ITEM2);
     }
-    
+
     rcrun = 0;
-    
+
     // Loop through inline extent entries
-    
+
     while (len > 0) {
         UINT8 secttype = *ptr;
         ULONG sectlen = get_extent_data_len(secttype);
         UINT64 sectcount = get_extent_data_refcount(secttype, ptr + sizeof(UINT8));
-        
+
         len--;
-        
+
         if (sectlen > len) {
             WARN("(%llx,%x,%llx): %x bytes left, expecting at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, len, sectlen);
             return FALSE;
@@ -1614,63 +1769,65 @@
             WARN("(%llx,%x,%llx): unrecognized extent type %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, secttype);
             return FALSE;
         }
-        
+
         if (secttype == TYPE_EXTENT_DATA_REF) {
             EXTENT_DATA_REF* sectedr = (EXTENT_DATA_REF*)(ptr + sizeof(UINT8));
-            
+
             if (root == 0 && inode == 0) {
                 root = sectedr->root;
                 inode = sectedr->objid;
-            } else if (root != sectedr->root || inode != sectedr->objid)
+                offset = sectedr->offset;
+            } else if (root != sectedr->root || inode != sectedr->objid || offset != sectedr->offset)
                 return FALSE;
         } else
             return FALSE;
-        
+
         len -= sectlen;
         ptr += sizeof(UINT8) + sectlen;
         rcrun += sectcount;
     }
-    
+
     if (rcrun == rc)
         return TRUE;
 
     // Loop through non-inlines if some refs still unaccounted for
-    
+
     do {
         b = find_next_item(Vcb, &tp, &next_tp, FALSE, Irp);
-        
+
         if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == TYPE_EXTENT_DATA_REF) {
             EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)tp.item->data;
-            
+
             if (tp.item->size < sizeof(EXTENT_DATA_REF)) {
                 WARN("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
                      tp.item->size, sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2));
                 return FALSE;
             }
-            
+
             if (root == 0 && inode == 0) {
                 root = edr->root;
                 inode = edr->objid;
-            } else if (root != edr->root || inode != edr->objid)
+                offset = edr->offset;
+            } else if (root != edr->root || inode != edr->objid || offset != edr->offset)
                 return FALSE;
-            
+
             rcrun += edr->count;
         }
-        
+
         if (rcrun == rc)
             return TRUE;
-        
+
         if (b) {
             tp = next_tp;
-            
+
             if (tp.item->key.obj_id > searchkey.obj_id)
                 break;
         }
     } while (b);
-    
+
     // If we reach this point, there's still some refs unaccounted for somewhere.
     // Return FALSE in case we mess things up elsewhere.
-    
+
     return FALSE;
 }
 
@@ -1679,39 +1836,39 @@
     traverse_ptr tp;
     NTSTATUS Status;
     EXTENT_ITEM* ei;
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA ? TYPE_METADATA_ITEM : TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return 0;
     }
-    
+
     if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA && tp.item->key.obj_id == address &&
         tp.item->key.obj_type == TYPE_METADATA_ITEM && tp.item->size >= sizeof(EXTENT_ITEM)) {
         ei = (EXTENT_ITEM*)tp.item->data;
-    
+
         return ei->flags;
     }
-    
+
     if (tp.item->key.obj_id != address || tp.item->key.obj_type != TYPE_EXTENT_ITEM) {
         ERR("couldn't find %llx in extent tree\n", address);
         return 0;
     }
-    
+
     if (tp.item->size == sizeof(EXTENT_ITEM_V0))
         return 0;
     else if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx) was %x bytes, expected at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type,
-                                                                   tp.item->key.offset, tp.item->size, sizeof(EXTENT_DATA));
+                                                                   tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return 0;
     }
-    
+
     ei = (EXTENT_ITEM*)tp.item->data;
-    
+
     return ei->flags;
 }
 
@@ -1720,17 +1877,17 @@
     traverse_ptr tp;
     NTSTATUS Status;
     EXTENT_ITEM* ei;
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA ? TYPE_METADATA_ITEM : TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return;
     }
-    
+
     if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA && tp.item->key.obj_id == address &&
         tp.item->key.obj_type == TYPE_METADATA_ITEM && tp.item->size >= sizeof(EXTENT_ITEM)) {
         ei = (EXTENT_ITEM*)tp.item->data;
